import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import * as d3 from 'd3';
var defaultLayout = {
  type: 'gridxy',
  aspectRatio: 'maxfill',
  size: {
    key: '',
    type: 'uniform',
    isShared: true
  },
  direction: 'LRBT',
  align: 'LB',
  margin: {
    top: 0,
    left: 0,
    bottom: 0,
    right: 0
  },
  padding: {
    top: 0,
    left: 0,
    bottom: 0,
    right: 0
  },
  sort: {
    type: 'categorical',
    key: '',
    direction: 'ascending'
  }
};
export var Layout = /*#__PURE__*/function () {
  _createClass(Layout, null, [{
    key: "START_OF",
    value: function START_OF() {
      var layout = new Layout();
      layout.startOf = true;
      return layout;
    }
  }, {
    key: "END_OF",
    value: function END_OF() {
      var layout = new Layout();
      layout.endOf = true;
      return layout;
    }
  }]);

  function Layout(options) {
    _classCallCheck(this, Layout);

    this.type = void 0;
    this.subgroup = void 0;
    this.size = void 0;
    this.aspectRatio = void 0;
    this.sizeSharingGroup = [];
    this.margin = void 0;
    this.padding = void 0;
    this.direction = void 0;
    this.align = void 0;
    this.sort = void 0;
    this.containers = void 0;
    this.startOf = void 0;
    this.endOf = void 0;
    this.parent = void 0;
    this.child = void 0;
    this.type = (options === null || options === void 0 ? void 0 : options.type) || defaultLayout.type;
    this.subgroup = options === null || options === void 0 ? void 0 : options.subgroup;
    this.size = (options === null || options === void 0 ? void 0 : options.size) || defaultLayout.size;
    this.aspectRatio = (options === null || options === void 0 ? void 0 : options.aspectRatio) || defaultLayout.aspectRatio;
    this.margin = _objectSpread(_objectSpread({}, defaultLayout.margin), options === null || options === void 0 ? void 0 : options.margin);
    this.padding = _objectSpread(_objectSpread({}, defaultLayout.padding), options === null || options === void 0 ? void 0 : options.padding);
    this.direction = (options === null || options === void 0 ? void 0 : options.direction) || defaultLayout.direction;
    this.align = (options === null || options === void 0 ? void 0 : options.align) || defaultLayout.align;
    this.sort = _objectSpread(_objectSpread({}, defaultLayout.sort), options === null || options === void 0 ? void 0 : options.sort);
  }

  _createClass(Layout, [{
    key: "isStartOf",
    value: function isStartOf() {
      return this.startOf;
    }
  }, {
    key: "isEndOf",
    value: function isEndOf() {
      return this.endOf;
    }
  }, {
    key: "setParent",
    value: function setParent(parent) {
      this.parent = parent;
    }
  }, {
    key: "setChild",
    value: function setChild(child) {
      this.child = child;
    }
  }, {
    key: "getParent",
    value: function getParent() {
      return this.parent;
    }
  }, {
    key: "getChild",
    value: function getChild() {
      return this.child;
    }
  }, {
    key: "apply",
    value: function apply(containers) {
      var _this = this;

      var childContainers = [];
      var newSizeSharingAncestor;
      var oldSizeSharingAncestor = this.getSharingAncestorContainer(containers[0], this, 'size');
      containers.forEach(function (container) {
        newSizeSharingAncestor = _this.getSharingAncestorContainer(container, _this, 'size');

        if (newSizeSharingAncestor !== oldSizeSharingAncestor) {
          _this.applySharedSize();

          oldSizeSharingAncestor = newSizeSharingAncestor;
        }

        var newContainers = _this.makeContainers(container);

        if (newContainers && newContainers.length > 0) {
          container.children = newContainers;

          _this.calcVisualSpace(container);
        }

        _this.handleSharedSize(container);

        childContainers = [].concat(_toConsumableArray(childContainers), _toConsumableArray(newContainers));
      });
      this.applySharedSize();
      return childContainers;
    }
  }, {
    key: "handleSharedSize",
    value: function handleSharedSize(container) {
      if (this.size.isShared) {
        if (!this.sizeSharingGroup) {
          this.sizeSharingGroup = [];
        }

        this.sizeSharingGroup = this.sizeSharingGroup.concat(container.children);
      }
    }
  }, {
    key: "getSharingAncestorContainer",
    value: function getSharingAncestorContainer(container, layout, item) {
      if (this.type === 'flatten') {
        return container;
      }

      if (layout[item] && layout[item].isShared) {
        if (container.parent !== undefined) {
          return this.getSharingAncestorContainer(container.parent, layout.getParent(), item);
        }
      }

      return container;
    }
  }, {
    key: "applySharedSize",
    value: function applySharedSize() {
      if (this.isEndOf() || this.size.isShared !== true) {
        return;
      }

      this.makeSharedSize();
      this.sizeSharingGroup = [];
    }
  }, {
    key: "makeSharedSize",
    value: function makeSharedSize() {
      switch (this.aspectRatio) {
        case 'fillX':
        case 'fillY':
          this.makeSharedSizeFill();
          break;

        case 'square':
        case 'parent':
        case 'custom':
        case 'maxfill':
          this.makeSharedSizePack();
          break;
      }
    }
  }, {
    key: "makeSharedSizeFill",
    value: function makeSharedSizeFill() {
      var minUnit = this.getMinUnitAmongContainers();
      this.applySharedUnitOnContainers(minUnit);
    }
  }, {
    key: "makeSharedSizePack",
    value: function makeSharedSizePack() {
      if (this.size.type === 'uniform') {
        var minSize = this.getMinAmongContainers();
        this.applySharedSizeOnContainers(minSize);
      } else {
        var minUnit = this.getMinUnitAmongContainers();
        this.applySharedUnitOnContainers(minUnit);
      }
    }
  }, {
    key: "getMinUnitAmongContainers",
    value: function getMinUnitAmongContainers() {
      var _this2 = this;

      var parentContainers = this.getParents(this.sizeSharingGroup);
      var minUnit = Number.MAX_VALUE;
      parentContainers.forEach(function (c) {
        var availableSpace = c.getAvailableSpace(_this2);

        var unit = _this2.getUnit(availableSpace, c.children);

        if (unit < minUnit) {
          minUnit = unit;
        }
      });
      return minUnit;
    }
  }, {
    key: "getMinAmongContainers",
    value: function getMinAmongContainers() {
      var sharedContainers = this.sizeSharingGroup;
      var minSizeItemIndex;

      switch (this.aspectRatio) {
        case 'square':
        case 'parent':
        case 'custom':
          minSizeItemIndex = d3.scan(sharedContainers, function (a, b) {
            return a.visualspace.width - b.visualspace.width;
          });
          return {
            width: sharedContainers[minSizeItemIndex].visualspace.width,
            height: sharedContainers[minSizeItemIndex].visualspace.height
          };

        case 'maxfill':
          var tempMinorSide = sharedContainers.map(function (d) {
            return d.visualspace.width > d.visualspace.height ? d.visualspace.height : d.visualspace.width;
          });
          minSizeItemIndex = d3.scan(tempMinorSide, function (a, b) {
            return a - b;
          });
          var minContainer = sharedContainers.reduce(function (pre, cur) {
            var minPre;
            var maxPre;
            var minCur;
            var maxCur;

            if (pre.visualspace.height > pre.visualspace.width) {
              minPre = pre.visualspace.width;
              maxPre = pre.visualspace.height;
            } else {
              minPre = pre.visualspace.height;
              maxPre = pre.visualspace.width;
            }

            if (cur.visualspace.height > cur.visualspace.width) {
              minCur = cur.visualspace.width;
              maxCur = cur.visualspace.height;
            } else {
              minCur = cur.visualspace.height;
              maxCur = cur.visualspace.width;
            }

            if (minCur < minPre) {
              return cur;
            } else if (minCur === minPre) {
              if (maxCur < maxPre) {
                return cur;
              }
            }

            return pre;
          });
          return {
            width: minContainer.visualspace.width,
            height: minContainer.visualspace.height
          };
      }
    }
  }, {
    key: "getParents",
    value: function getParents(containers) {
      var parentSet = new Set();
      containers.forEach(function (d) {
        if (d.parent) {
          parentSet.add(d.parent);
        }
      });
      return Array.from(parentSet);
    }
  }, {
    key: "getUnit",
    value: function getUnit(availableSpace, childContainers) {
      var _this3 = this;

      var sum = childContainers.reduce(function (cur, prev) {
        return cur + _this3.getValue(prev);
      }, 0);
      return availableSpace / sum;
    }
  }, {
    key: "getValue",
    value: function getValue(container) {
      var _this4 = this;

      switch (this.size.type) {
        case 'uniform':
          return 1;

        case 'sum':
          // @ts-ignore
          return d3.sum(container.data, function (d) {
            return d[_this4.size.key];
          });

        case 'count':
          return container.data.length;

        default:
          return 1;
      }
    }
  }, {
    key: "applySharedSizeOnContainers",
    value: function applySharedSizeOnContainers(minSize) {
      var _this5 = this;

      this.getParents(this.sizeSharingGroup).forEach(function (c) {
        var edgeInfo = _this5.buildEdgeInfoFromMinSize(c, minSize);

        _this5.applyEdgeInfo(c, edgeInfo);
      });
    }
  }, {
    key: "applySharedUnitOnContainers",
    value: function applySharedUnitOnContainers(minUnit) {
      var _this6 = this;

      this.getParents(this.sizeSharingGroup).forEach(function (d) {
        switch (_this6.aspectRatio) {
          case 'fillX':
          case 'fillY':
            _this6.calcFillGridxyVisualSpaceWithUnitLength(d, minUnit);

            break;

          case 'square':
          case 'parent':
          case 'custom':
          case 'maxfill':
            _this6.calcPackGridxyVisualSpaceWithUnitLength(d, minUnit);

        }
      });
    }
  }, {
    key: "calcFillGridxyVisualSpaceWithUnitLength",
    value: function calcFillGridxyVisualSpaceWithUnitLength(parentContainer, unitLength) {
      var _this7 = this;

      var parentVisualSpace = parentContainer.visualspace;

      if (this.aspectRatio === 'fillX') {
        var unitWidth = unitLength;
        parentContainer.children.forEach(function (c) {
          c.visualspace.width = unitWidth * _this7.getValue(c) - _this7.margin.left - _this7.margin.right;
          c.visualspace.height = parentVisualSpace.height - parentVisualSpace.padding.top - parentVisualSpace.padding.bottom - _this7.margin.top - _this7.margin.bottom;
          c.visualspace.posY = parentVisualSpace.padding.top + _this7.margin.top;
          c.visualspace.padding = _this7.padding;
        });
        this.getPosXforFillX(parentVisualSpace, parentContainer.children);
      } else if (this.aspectRatio === 'fillY') {
        var unitHeight = unitLength;
        parentContainer.children.forEach(function (c) {
          c.visualspace.height = unitHeight * _this7.getValue(c) - _this7.margin.top - _this7.margin.bottom;
          c.visualspace.width = parentVisualSpace.width - parentVisualSpace.padding.left - parentVisualSpace.padding.right - _this7.margin.left - _this7.margin.right;
          c.visualspace.posX = parentVisualSpace.padding.left + _this7.margin.left;
          c.visualspace.padding = _this7.padding;
        });
        this.getPosYforFillY(parentVisualSpace, parentContainer.children);
      } else {// TODO: other aspectRatios
      }
    }
  }, {
    key: "calcPackGridxyVisualSpaceWithUnitLength",
    value: function calcPackGridxyVisualSpaceWithUnitLength(parentContainer, unitLength) {
      var _this8 = this;

      switch (this.aspectRatio) {
        case 'square':
          parentContainer.children.forEach(function (c, i, all) {
            c.visualspace.width = Math.sqrt(unitLength * _this8.getValue(c));
            c.visualspace.height = Math.sqrt(unitLength * _this8.getValue(c));
            c.visualspace.posX = parentContainer.visualspace.padding.left + _this8.margin.left + 0.5 * (parentContainer.visualspace.width - c.visualspace.width - parentContainer.visualspace.padding.left - parentContainer.visualspace.padding.right);
            c.visualspace.posY = parentContainer.visualspace.padding.top + _this8.margin.top + 0.5 * (parentContainer.visualspace.height - c.visualspace.height - parentContainer.visualspace.padding.top - parentContainer.visualspace.padding.right);
          });
      }
    }
  }, {
    key: "getPosXforFillX",
    value: function getPosXforFillX(parentVisualspace, childContainers) {
      var _this9 = this;

      var start;
      var direction;
      var offset;

      switch (this.direction) {
        case 'LRTB':
        case 'LRBT':
        case 'TBLR':
        case 'BTLR':
        case 'LR':
          start = 0;
          direction = 1;
          break;

        case 'RLBT':
        case 'RLTB':
        case 'BTRL':
        case 'TBRL':
        case 'RL':
          start = childContainers.length - 1;
          direction = -1;
          break;

        default:
      }

      var totalwidth = childContainers.reduce(function (cur, c) {
        return cur + c.visualspace.width + _this9.margin.left + _this9.margin.right;
      }, 0);

      switch (this.align) {
        case 'left':
        case 'LT':
        case 'LM':
        case 'LB':
          offset = parentVisualspace.padding.left;
          break;

        case 'center':
        case 'CT':
        case 'CM':
        case 'CB':
          offset = parentVisualspace.padding.left + (parentVisualspace.width - parentVisualspace.padding.left - parentVisualspace.padding.right) / 2 - totalwidth / 2;
          break;

        case 'right':
        case 'RT':
        case 'RM':
        case 'RB':
          offset = parentVisualspace.width - parentVisualspace.padding.right - totalwidth;
          break;
      }

      childContainers.forEach(function (c, i, all) {
        var index = start + direction * i;

        if (i === 0) {
          all[index].visualspace.posX = offset + _this9.margin.left;
        } else {
          all[index].visualspace.posX = all[index - direction].visualspace.posX + all[index - direction].visualspace.width + _this9.margin.right + _this9.margin.left;
        }
      });
    }
  }, {
    key: "getPosYforFillY",
    value: function getPosYforFillY(parentVisualspace, childContainers) {
      var _this10 = this;

      var start;
      var direction;
      var offset;

      switch (this.direction) {
        case 'LRTB':
        case 'RLTB':
        case 'TBLR':
        case 'TBRL':
        case 'TB':
          start = 0;
          direction = 1;
          break;

        case 'LRBT':
        case 'RLBT':
        case 'BTLR':
        case 'BTRL':
        case 'BT':
          start = childContainers.length - 1;
          direction = -1;
          break;

        default:
      }

      var totalheight = childContainers.reduce(function (cur, c) {
        return cur + c.visualspace.height + _this10.margin.top + _this10.margin.bottom;
      }, 0);

      switch (this.align) {
        case 'top':
        case 'RT':
        case 'CT':
        case 'LT':
          offset = parentVisualspace.padding.top;
          break;

        case 'middle':
        case 'LM':
        case 'RM':
        case 'CM':
          offset = parentVisualspace.padding.top + (parentVisualspace.height - parentVisualspace.padding.top - parentVisualspace.padding.bottom) / 2 - totalheight / 2;
          break;

        case 'bottom':
        case 'LB':
        case 'CB':
        case 'RB':
          offset = parentVisualspace.height - parentVisualspace.padding.bottom - totalheight;
          break;
      }

      childContainers.forEach(function (c, i, all) {
        var index = start + direction * i;

        if (i === 0) {
          all[index].visualspace.posY = offset + _this10.margin.top;
        } else {
          all[index].visualspace.posY = all[index - direction].visualspace.posY + all[index - direction].visualspace.height + _this10.margin.bottom + _this10.margin.top;
        }
      });
    }
  }, {
    key: "getSharingDomain",
    value: function getSharingDomain(container) {
      var _this11 = this;

      if (this.isContainer(container)) {
        var _children;

        if (!container.children || ((_children = container.children) === null || _children === void 0 ? void 0 : _children.length) === 0) {
          // @ts-ignore
          return container.data;
        }

        var leafs = [];
        container.children.forEach(function (c) {
          var newLeaves = _this11.getSharingDomain(c);

          newLeaves.forEach(function (d) {
            leafs.push(d);
          });
        });
        return leafs;
      } else {
        return [container];
      }
    }
  }, {
    key: "isContainer",
    value: function isContainer(container) {
      if (container.hasOwnProperty('data') && container.hasOwnProperty('visualspace') && container.hasOwnProperty('parent')) {
        return true;
      }

      return false;
    }
  }, {
    key: "makeContainers",
    value: function makeContainers(container) {
      var sharingAncestorContainer = this.getSharingAncestorContainer(container, this, 'subgroup');
      var sharingDomain = this.getSharingDomain(sharingAncestorContainer);
      var childContainers;

      if (this.subgroup) {
        switch (this.subgroup.type) {
          case 'groupby':
            childContainers = container.makeContainersForCategoricalVar( // @ts-ignore
            sharingDomain, this.subgroup.key);
            break;

          case 'bin':
            childContainers = container.makeContainersForNumericalVar( // @ts-ignore
            sharingDomain, this.subgroup);
            break;

          case 'passthrough':
            childContainers = container.makeContainersForPassthrough();
            break;

          case 'flatten':
            childContainers = container.makeContainersForFlatten(this.sort);
            break;
        }
      }

      return childContainers;
    }
  }, {
    key: "calcVisualSpace",
    value: function calcVisualSpace(parentContainer) {
      this.containers = parentContainer.children;

      switch (this.type) {
        case 'gridxy':
          this.calcGridxyVisualSpace(parentContainer);
          break;

        default: // TODO: flatten

      }
    }
  }, {
    key: "calcGridxyVisualSpace",
    value: function calcGridxyVisualSpace(parentContainer) {
      switch (this.aspectRatio) {
        case 'fillX':
        case 'fillY':
          this.calcFillGridxyVisualSpace(parentContainer);
          break;

        case 'square':
        case 'parent':
        case 'custom':
          this.calcPackGridxyVisualSpace(parentContainer);
          break;

        case 'maxfill':
          this.calcPackGridxyMaxFillVisualSpace(parentContainer);
      }
    }
  }, {
    key: "calcFillGridxyVisualSpace",
    value: function calcFillGridxyVisualSpace(parentContainer) {
      var availableSpace = parentContainer.getAvailableSpace(this);
      var unitLength = this.getUnit(availableSpace, parentContainer.children);
      this.calcFillGridxyVisualSpaceWithUnitLength(parentContainer, unitLength);
    }
  }, {
    key: "calcPackGridxyVisualSpace",
    value: function calcPackGridxyVisualSpace(parentContainer) {
      var aspectRatio = 1;

      switch (this.aspectRatio) {
        case 'square':
          aspectRatio = 1;
          break;

        case 'parent':
          aspectRatio = parentContainer.visualspace.width / parentContainer.visualspace.height;
          break;
      }

      var edgeInfo = this.calcEdgeInfo(parentContainer, aspectRatio);
      this.applyEdgeInfo(parentContainer, edgeInfo);
    }
  }, {
    key: "calcPackGridxyMaxFillVisualSpace",
    value: function calcPackGridxyMaxFillVisualSpace(parentContainer) {
      if (this.size.type === 'uniform') {
        this.calcPackGridxyMaxFillVisualSpaceUniform(parentContainer);
      } else {// TODO:
        // this.calcPackGridxyMaxFillVisualSpaceFunction(
        //   parentContainer,
        //   childContainers,
        //   layout,
        // );
      }
    }
  }, {
    key: "calcPackGridxyMaxFillVisualSpaceUniform",
    value: function calcPackGridxyMaxFillVisualSpaceUniform(parentContainer) {
      var edgeInfo = this.buildEdgeInfoForMaxFill(parentContainer);
      this.applyEdgeInfo(parentContainer, edgeInfo);
    }
  }, {
    key: "calcEdgeInfo",
    value: function calcEdgeInfo(parentContainer, aspectRatio) {
      return this.isVerticalDirection(this.direction) ? this.getRepetitionCountForFillingEdge(parentContainer.visualspace.width, parentContainer.visualspace.height, parentContainer.children.length, aspectRatio) : this.getRepetitionCountForFillingEdge(parentContainer.visualspace.height, parentContainer.visualspace.width, parentContainer.children.length, 1 / aspectRatio);
    }
  }, {
    key: "getRepetitionCountForFillingEdge",
    value: function getRepetitionCountForFillingEdge(fillingEdge, remainingEdge, numElement, ratio) {
      var fillingEdgeRepetitionCount = 0;
      var remainingEdgeSideUnitLength;
      var remainingEdgeRepetitionCount;
      var numPossibleContainers;
      var fillingEdgeSideUnitLength;

      do {
        fillingEdgeRepetitionCount++;
        fillingEdgeSideUnitLength = 1.0 * fillingEdge / fillingEdgeRepetitionCount;
        remainingEdgeSideUnitLength = fillingEdgeSideUnitLength / ratio;
        remainingEdgeRepetitionCount = Math.floor(remainingEdge * fillingEdgeRepetitionCount * ratio / fillingEdge);
        numPossibleContainers = remainingEdgeRepetitionCount * fillingEdgeRepetitionCount;
      } while (numElement > numPossibleContainers);

      return {
        fillingEdgeRepetitionCount: fillingEdgeRepetitionCount,
        remainingEdgeRepetitionCount: remainingEdgeRepetitionCount,
        fillingEdgeSideUnitLength: fillingEdgeSideUnitLength,
        remainingEdgeSideUnitLength: remainingEdgeSideUnitLength
      };
    }
  }, {
    key: "applyEdgeInfo",
    value: function applyEdgeInfo(parentContainer, edgeInfo) {
      if (this.isVerticalDirection(this.direction)) {
        this.applyEdgeInfoVerticalDirection(parentContainer, edgeInfo);
      } else {
        this.applyEdgeInfoHorizontalDirection(parentContainer, edgeInfo);
      }
    }
  }, {
    key: "applyEdgeInfoHorizontalDirection",
    value: function applyEdgeInfoHorizontalDirection(parentContainer, edgeInfo) {
      var _this12 = this;

      var xOrig;
      var yOrig;
      var xInc;
      var yInc;
      var numVerticalElement;

      switch (this.direction) {
        case 'TBLR':
          xOrig = 0;
          yOrig = 0;
          xInc = edgeInfo.remainingEdgeSideUnitLength;
          yInc = edgeInfo.fillingEdgeSideUnitLength;
          numVerticalElement = edgeInfo.fillingEdgeRepetitionCount;
          break;

        case 'BTLR':
          xOrig = 0;
          yOrig = parentContainer.visualspace.height - edgeInfo.remainingEdgeSideUnitLength;
          xInc = edgeInfo.remainingEdgeSideUnitLength;
          yInc = -1.0 * edgeInfo.fillingEdgeSideUnitLength;
          numVerticalElement = edgeInfo.fillingEdgeRepetitionCount;
          break;

        case 'TBRL':
        case 'BTRL':
          // TODO:
          break;
      }

      parentContainer.children.forEach(function (c, i) {
        c.visualspace.width = edgeInfo.remainingEdgeSideUnitLength;
        c.visualspace.height = edgeInfo.fillingEdgeSideUnitLength;
        c.visualspace.posX = xOrig + xInc * Math.floor(i / numVerticalElement);
        c.visualspace.posY = yOrig + yInc * (i % numVerticalElement);
        c.visualspace.padding = _this12.padding;
      });
    }
  }, {
    key: "applyEdgeInfoVerticalDirection",
    value: function applyEdgeInfoVerticalDirection(parentContainer, edgeInfo) {
      var _this13 = this;

      var xOrig;
      var yOrig;
      var xInc;
      var yInc;
      var numHoriElement;

      switch (this.direction) {
        case 'LRTB':
          xOrig = 0;
          yOrig = 0;
          xInc = edgeInfo.fillingEdgeSideUnitLength;
          yInc = edgeInfo.remainingEdgeSideUnitLength;
          numHoriElement = edgeInfo.fillingEdgeRepetitionCount;
          break;

        case 'LRBT':
          xOrig = 0;
          yOrig = parentContainer.visualspace.height - edgeInfo.remainingEdgeSideUnitLength;
          xInc = edgeInfo.fillingEdgeSideUnitLength;
          yInc = -1.0 * edgeInfo.remainingEdgeSideUnitLength;
          numHoriElement = edgeInfo.fillingEdgeRepetitionCount;
          break;

        case 'RLBT':
        case 'RLTB':
          // TODO:
          break;
      }

      parentContainer.children.forEach(function (c, i) {
        c.visualspace.width = edgeInfo.fillingEdgeSideUnitLength;
        c.visualspace.height = edgeInfo.remainingEdgeSideUnitLength;
        c.visualspace.posX = xOrig + xInc * (i % numHoriElement);
        c.visualspace.posY = yOrig + yInc * Math.floor(i / numHoriElement);
        c.visualspace.padding = _this13.padding;
      });
    }
  }, {
    key: "getCombination",
    value: function getCombination(n) {
      return d3.range(1, n + 1).map(function (d) {
        return {
          a: d,
          b: Math.ceil(n / d)
        };
      });
    }
  }, {
    key: "buildEdgeInfoFromMinSize",
    value: function buildEdgeInfoFromMinSize(parentContainer, minSize) {
      var horizontalRepetitionCount = Math.floor(parentContainer.visualspace.width / minSize.width);
      var verticalRepetitionCount = Math.floor(parentContainer.visualspace.height / minSize.height);
      return this.buildEdgeInfoByDirection(horizontalRepetitionCount, verticalRepetitionCount, minSize.width, minSize.height);
    }
  }, {
    key: "buildEdgeInfoByDirection",
    value: function buildEdgeInfoByDirection(horizontalRepetitionCount, verticalRepetitionCount, width, height) {
      var fillingEdgeRepetitionCount;
      var remainingEdgeRepetitionCount;
      var fillingEdgeSideUnitLength;
      var remainingEdgeSideUnitLength;

      if (this.isVerticalDirection(this.direction)) {
        fillingEdgeRepetitionCount = horizontalRepetitionCount;
        remainingEdgeRepetitionCount = verticalRepetitionCount;
        fillingEdgeSideUnitLength = width;
        remainingEdgeSideUnitLength = height;
      } else {
        fillingEdgeRepetitionCount = verticalRepetitionCount;
        remainingEdgeRepetitionCount = horizontalRepetitionCount;
        fillingEdgeSideUnitLength = height;
        remainingEdgeSideUnitLength = width;
      }

      return {
        fillingEdgeRepetitionCount: fillingEdgeRepetitionCount,
        remainingEdgeRepetitionCount: remainingEdgeRepetitionCount,
        fillingEdgeSideUnitLength: fillingEdgeSideUnitLength,
        remainingEdgeSideUnitLength: remainingEdgeSideUnitLength
      };
    }
  }, {
    key: "isVerticalDirection",
    value: function isVerticalDirection(direction) {
      switch (direction) {
        case 'LRBT':
        case 'LRTB':
        case 'RLBT':
        case 'RLTB':
          return true;

        case 'BTLR':
        case 'BTRL':
        case 'TBLR':
        case 'TBRL':
          return false;
      }
    }
  }, {
    key: "buildEdgeInfoForMaxFill",
    value: function buildEdgeInfoForMaxFill(parentContainer) {
      var combinations = this.getCombination(parentContainer.children.length);
      var combinationForWidthAndHeight = combinations.map(function (d) {
        return {
          width: parentContainer.visualspace.width / d.a,
          height: parentContainer.visualspace.height / d.b,
          horizontalRepetitionCount: d.a,
          verticalRepetitionCount: d.b,
          minEdge: 0
        };
      });
      combinationForWidthAndHeight.forEach(function (d) {
        d.minEdge = d.width > d.height ? d.height : d.width;
      });
      var minCombi = d3.scan(combinationForWidthAndHeight, function (a, b) {
        return b.minEdge - a.minEdge;
      });
      var edgeInfo = combinationForWidthAndHeight[minCombi];
      return this.buildEdgeInfoByDirection(edgeInfo.horizontalRepetitionCount, edgeInfo.verticalRepetitionCount, edgeInfo.width, edgeInfo.height);
    }
  }]);

  return Layout;
}();
//# sourceMappingURL=Layout.js.map