"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.encodePickingColor = encodePickingColor;
exports.Mark = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var d3 = _interopRequireWildcard(require("d3"));

/* babel-plugin-inline-import './shaders/webgl.point.frag.glsl' */
var fragmentShaderGLSL = "uniform float u_blur;\nuniform float u_opacity;\nuniform float u_stroke_width;\nuniform vec4 u_stroke_color;\nuniform float u_stroke_opacity;\n\nvarying vec4 v_color;\nvarying vec4 v_data;\nvarying float v_radius;\n\n#pragma include \"sdf2d\"\n#pragma include \"picking\"\n\nvoid main() {\n  int shape = int(floor(v_data.w + 0.5));\n\n  float antialiasblur = v_data.z;\n  float antialiased_blur = -max(u_blur, antialiasblur);\n  float r = v_radius / (v_radius + u_stroke_width);\n\n  float outer_df;\n  float inner_df;\n  // 'circle', 'triangle', 'square', 'pentagon', 'hexagon', 'octogon', 'hexagram', 'rhombus', 'vesica'\n  if (shape == 0) {\n    outer_df = sdCircle(v_data.xy, 1.0);\n    inner_df = sdCircle(v_data.xy, r);\n  } else if (shape == 1) {\n    outer_df = sdEquilateralTriangle(1.1 * v_data.xy);\n    inner_df = sdEquilateralTriangle(1.1 / r * v_data.xy);\n  } else if (shape == 2) {\n    outer_df = sdBox(v_data.xy, vec2(1.));\n    inner_df = sdBox(v_data.xy, vec2(r));\n  } else if (shape == 3) {\n    outer_df = sdPentagon(v_data.xy, 0.8);\n    inner_df = sdPentagon(v_data.xy, r * 0.8);\n  } else if (shape == 4) {\n    outer_df = sdHexagon(v_data.xy, 0.8);\n    inner_df = sdHexagon(v_data.xy, r * 0.8);\n  } else if (shape == 5) {\n    outer_df = sdOctogon(v_data.xy, 1.0);\n    inner_df = sdOctogon(v_data.xy, r);\n  } else if (shape == 6) {\n    outer_df = sdHexagram(v_data.xy, 0.52);\n    inner_df = sdHexagram(v_data.xy, r * 0.52);\n  } else if (shape == 7) {\n    outer_df = sdRhombus(v_data.xy, vec2(1.0));\n    inner_df = sdRhombus(v_data.xy, vec2(r));\n  } else if (shape == 8) {\n    outer_df = sdVesica(v_data.xy, 1.1, 0.8);\n    inner_df = sdVesica(v_data.xy, r * 1.1, r * 0.8);\n  }\n\n  float opacity_t = smoothstep(0.0, antialiased_blur, outer_df);\n\n  float color_t = u_stroke_width < 0.01 ? 0.0 : smoothstep(\n    antialiased_blur,\n    0.0,\n    inner_df\n  );\n  vec4 strokeColor = u_stroke_color == vec4(0) ? v_color : u_stroke_color;\n\n  gl_FragColor = mix(vec4(v_color.rgb, v_color.a * u_opacity), strokeColor * u_stroke_opacity, color_t);\n  gl_FragColor.a = gl_FragColor.a * opacity_t;\n\n  gl_FragColor = filterColor(gl_FragColor);\n}";

/* babel-plugin-inline-import './shaders/webgl.point.vert.glsl' */
var vertexShaderGLSL = "#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966\n#endif\n\n#ifndef PI\n#define PI 3.141592653589793\n#endif\n\nfloat bounceOut(float t) {\n  const float a = 4.0 / 11.0;\n  const float b = 8.0 / 11.0;\n  const float c = 9.0 / 10.0;\n\n  const float ca = 4356.0 / 361.0;\n  const float cb = 35442.0 / 1805.0;\n  const float cc = 16061.0 / 1805.0;\n\n  float t2 = t * t;\n\n  return t < a\n    ? 7.5625 * t2\n    : t < b\n      ? 9.075 * t2 - 9.9 * t + 3.4\n      : t < c\n        ? ca * t2 - cb * t + cc\n        : 10.8 * t * t - 20.52 * t + 10.72;\n}\n\nfloat elasticInOut(float t) {\n  return t < 0.5\n    ? 0.5 * sin(+13.0 * HALF_PI * 2.0 * t) * pow(2.0, 10.0 * (2.0 * t - 1.0))\n    : 0.5 * sin(-13.0 * HALF_PI * ((2.0 * t - 1.0) + 1.0)) * pow(2.0, -10.0 * (2.0 * t - 1.0)) + 1.0;\n}\n\nfloat elasticIn(float t) {\n  return sin(13.0 * t * HALF_PI) * pow(2.0, 10.0 * (t - 1.0));\n}\n\nfloat linear(float t) {\n  return t;\n}\n\nattribute vec2 position;\nattribute vec2 startOffset;\nattribute vec2 endOffset;\nattribute vec4 color;\nattribute float startSize;\nattribute float endSize;\nattribute float shape;\n\nuniform mat4 projectionMatrix;\nuniform mat4 modelViewMatrix;\n\nuniform float u_stroke_width;\nuniform float u_device_pixel_ratio;\nuniform vec2 u_viewport;\nuniform float u_time;\n\nvarying vec4 v_color;\nvarying vec4 v_data;\nvarying float v_radius;\n\n#pragma include \"picking\"\n\nvoid main() {\n  v_color = color;\n\n  float interpolatedSize = mix(startSize, endSize, linear(u_time));\n  // \u9488\u5BF9\u4F4D\u7F6E\u504F\u79FB\u8FDB\u884C\u63D2\u503C\n  vec2 interpolatedOffset = mix(startOffset, endOffset, linear(u_time));\n\n  v_radius = interpolatedSize;\n\n  lowp float antialiasblur = 1.0 / u_device_pixel_ratio / (interpolatedSize + u_stroke_width);\n\n  // construct point coords\n  v_data = vec4(position, antialiasblur, shape);\n\n  // projectionMatrix * modelViewMatrix * \n  gl_Position = vec4(position * interpolatedSize * 2.0 / u_viewport + interpolatedOffset, 0.0, 1.0);\n\n  setPickingColor(a_PickingColor);\n}";

function encodePickingColor(featureIdx) {
  return [featureIdx + 1 & 255, featureIdx + 1 >> 8 & 255, featureIdx + 1 >> 8 >> 8 & 255];
}

var Mark = /*#__PURE__*/function () {
  function Mark(options) {
    (0, _classCallCheck2.default)(this, Mark);
    this.options = options;
    this.colorScale = void 0;
    this.world = void 0;
    this.material = void 0;
    this.geometry = void 0;
    this.startTime = void 0;
    this.activeLayout = void 0;
    this.inited = void 0;
    this.attributesMap = {};
  }

  (0, _createClass2.default)(Mark, [{
    key: "update",
    value: function update() {
      if (!this.startTime) {
        this.startTime = window.performance.now();
      } else {
        var elaspedTime = window.performance.now() - this.startTime;

        if (elaspedTime < 600) {
          this.material.setUniform('u_time', elaspedTime / 600);
        } else {
          this.material.setUniform('u_time', 1);
        }
      }
    }
  }, {
    key: "buildAttributesForAllContainers",
    value: function buildAttributesForAllContainers(containerMap) {
      var _this = this;

      if (this.options.color.type === 'categorical') {
        this.colorScale = d3.scaleOrdinal(d3.schemeCategory10);
      }

      Object.keys(containerMap).forEach(function (layoutName) {
        _this.attributesMap[layoutName] = {
          positions: [1, 1, 1, -1, -1, -1, -1, 1],
          instancedStartOffsets: [],
          instancedEndOffsets: [],
          instancedColors: [],
          instancedStartSizes: [],
          instancedEndSizes: [],
          instancedShapes: [],
          instancedPickingColors: []
        };

        _this.buildAttributes(containerMap[layoutName], containerMap[layoutName], _this.attributesMap[layoutName]);
      });
    }
  }, {
    key: "render",
    value: function render(world, scene, rootContainer, layout) {
      this.world = world;
      var attributes = this.attributesMap[layout];

      if (!this.inited) {
        // create geometry, material and attach them to mesh
        var geometry = world.createInstancedBufferGeometry({
          maxInstancedCount: attributes.instancedStartOffsets.length / 2,
          vertexCount: 6
        });
        this.geometry = geometry;
        geometry.setIndex([0, 2, 1, 0, 3, 2]);
        geometry.setAttribute('position', Float32Array.from(attributes.positions), {
          arrayStride: 4 * 2,
          stepMode: 'vertex',
          attributes: [{
            shaderLocation: 0,
            offset: 0,
            format: 'float2'
          }]
        });
        geometry.setAttribute('startOffset', Float32Array.from(attributes.instancedStartOffsets), {
          arrayStride: 4 * 2,
          stepMode: 'instance',
          attributes: [{
            shaderLocation: 1,
            offset: 0,
            format: 'float2'
          }]
        });
        geometry.setAttribute('color', Float32Array.from(attributes.instancedColors), {
          arrayStride: 4 * 4,
          stepMode: 'instance',
          attributes: [{
            shaderLocation: 2,
            offset: 0,
            format: 'float4'
          }]
        });
        geometry.setAttribute('startSize', Float32Array.from(attributes.instancedStartSizes), {
          arrayStride: 4,
          stepMode: 'instance',
          attributes: [{
            shaderLocation: 3,
            offset: 0,
            format: 'float'
          }]
        });
        geometry.setAttribute('endSize', Float32Array.from(attributes.instancedEndSizes), {
          arrayStride: 4,
          stepMode: 'instance',
          attributes: [{
            shaderLocation: 3,
            offset: 0,
            format: 'float'
          }]
        });
        geometry.setAttribute('shape', Float32Array.from(attributes.instancedShapes), {
          arrayStride: 4,
          stepMode: 'instance',
          attributes: [{
            shaderLocation: 4,
            offset: 0,
            format: 'float'
          }]
        });
        geometry.setAttribute('endOffset', Float32Array.from(attributes.instancedEndOffsets), {
          arrayStride: 4 * 2,
          stepMode: 'instance',
          attributes: [{
            shaderLocation: 5,
            offset: 0,
            format: 'float2'
          }]
        });
        geometry.setAttribute('a_PickingColor', Float32Array.from(attributes.instancedPickingColors), {
          arrayStride: 4 * 3,
          stepMode: 'instance',
          attributes: [{
            shaderLocation: 6,
            offset: 0,
            format: 'float3'
          }]
        });
        var material = world.createShaderMaterial({
          vertexShader: vertexShaderGLSL,
          fragmentShader: fragmentShaderGLSL
        });
        this.material = material;
        var _rootContainer$visual = rootContainer.visualspace,
            rootWidth = _rootContainer$visual.width,
            rootHeight = _rootContainer$visual.height;
        material.setUniform({
          u_stroke_width: 1,
          u_device_pixel_ratio: window.devicePixelRatio,
          u_stroke_color: [0, 0, 0, 0],
          u_stroke_opacity: 1,
          u_opacity: 0.35,
          u_blur: 0.2,
          u_time: 0,
          u_viewport: [rootWidth, rootHeight]
        }); // add meshes to current scene

        var entity = world.createEntity();
        scene.addEntity(entity);
        world.createRenderable(entity).setGeometry(geometry).setMaterial(material);
        this.inited = true;
      } else {
        // 布局切换，更新顶点数据
        if (this.activeLayout !== layout) {
          var currentAttributes = this.attributesMap[this.activeLayout];
          this.geometry.setAttribute('startOffset', Float32Array.from(currentAttributes.instancedEndOffsets), {
            arrayStride: 4 * 2,
            stepMode: 'instance',
            attributes: [{
              shaderLocation: 1,
              offset: 0,
              format: 'float2'
            }]
          });
          this.geometry.setAttribute('endOffset', Float32Array.from(attributes.instancedEndOffsets), {
            arrayStride: 4 * 2,
            stepMode: 'instance',
            attributes: [{
              shaderLocation: 5,
              offset: 0,
              format: 'float2'
            }]
          });
          this.geometry.setAttribute('startSize', Float32Array.from(currentAttributes.instancedEndSizes), {
            arrayStride: 4,
            stepMode: 'instance',
            attributes: [{
              shaderLocation: 3,
              offset: 0,
              format: 'float'
            }]
          });
          this.geometry.setAttribute('endSize', Float32Array.from(attributes.instancedEndSizes), {
            arrayStride: 4,
            stepMode: 'instance',
            attributes: [{
              shaderLocation: 3,
              offset: 0,
              format: 'float'
            }]
          });
        }

        this.startTime = window.performance.now();
      }

      this.activeLayout = layout;
    }
  }, {
    key: "buildAttributes",
    value: function buildAttributes(container, rootContainer, attributes) {
      var _this2 = this;

      container.children.forEach(function (childContainer) {
        if (!_this2.isContainer(childContainer)) {
          _this2.buildMark(container, rootContainer, attributes);
        } else {
          _this2.buildAttributes(childContainer, rootContainer, attributes);
        }
      });
    }
  }, {
    key: "isContainer",
    value: function isContainer(container) {
      if (container.hasOwnProperty('data') && container.hasOwnProperty('visualspace') && container.hasOwnProperty('parent')) {
        return true;
      }

      return false;
    }
  }, {
    key: "buildMark",
    value: function buildMark(container, rootContainer, attributes) {
      var _d3$color;

      var _container$visualspac = container.visualspace,
          posX = _container$visualspac.posX,
          posY = _container$visualspac.posY,
          width = _container$visualspac.width,
          height = _container$visualspac.height;
      var _visualspace = container.parent.visualspace,
          parentPosX = _visualspace.posX,
          parentPosY = _visualspace.posY;
      var _rootContainer$visual2 = rootContainer.visualspace,
          rootWidth = _rootContainer$visual2.width,
          rootHeight = _rootContainer$visual2.height;
      var index = Number(container.data[0].$unitChartId);
      attributes.instancedStartSizes[index] = width / 2;
      attributes.instancedEndSizes[index] = width / 2; // attributes.instancedStartSizes.push(width / 2);
      // attributes.instancedEndSizes.push(width / 2);

      var color = (_d3$color = d3 // @ts-ignore
      .color(this.colorScale(container.data[0][this.options.color.key]))) === null || _d3$color === void 0 ? void 0 : _d3$color.rgb();

      if (color) {
        var r = color.r,
            g = color.g,
            b = color.b;
        attributes.instancedColors[index * 4] = r / 255;
        attributes.instancedColors[index * 4 + 1] = g / 255;
        attributes.instancedColors[index * 4 + 2] = b / 255;
        attributes.instancedColors[index * 4 + 3] = 1; // attributes.instancedColors.push(r / 255, g / 255, b / 255, 1);
        // attributes.instancedEndOffsets.push(
        //   this.convertCanvas2WebGLCoord(posX + parentPosX, rootWidth),
        //   -this.convertCanvas2WebGLCoord(posY + parentPosY, rootHeight),
        // );
        // attributes.instancedStartOffsets.push(
        //   Math.random() * 2 - 1,
        //   Math.random() * 2 - 1,
        // );

        attributes.instancedEndOffsets[index * 2] = this.convertCanvas2WebGLCoord(posX + parentPosX, rootWidth);
        attributes.instancedEndOffsets[index * 2 + 1] = -this.convertCanvas2WebGLCoord(posY + parentPosY, rootHeight);
        attributes.instancedStartOffsets[index * 2] = Math.random() * 2 - 1;
        attributes.instancedStartOffsets[index * 2 + 1] = Math.random() * 2 - 1; // attributes.instancedShapes.push(0);

        attributes.instancedShapes[index] = 0; // attributes.instancedPickingColors.push(
        //   ...encodePickingColor(Number(container.contents[0].$unitChartId)),
        // );

        var _encodePickingColor = encodePickingColor(Number(container.data[0].$unitChartId)),
            _encodePickingColor2 = (0, _slicedToArray2.default)(_encodePickingColor, 3),
            encodedR = _encodePickingColor2[0],
            encodedG = _encodePickingColor2[1],
            encodedB = _encodePickingColor2[2];

        attributes.instancedPickingColors[index * 3] = encodedR;
        attributes.instancedPickingColors[index * 3 + 1] = encodedG;
        attributes.instancedPickingColors[index * 3 + 2] = encodedB;
      }
    }
  }, {
    key: "convertCanvas2WebGLCoord",
    value: function convertCanvas2WebGLCoord(c, size) {
      return c / size * 2 - 1;
    }
  }]);
  return Mark;
}();

exports.Mark = Mark;
//# sourceMappingURL=Mark.js.map